from data import data_dir, connect
import numpy as np
import sklearn
from sklearn.cluster import MiniBatchKMeans


@click.command(name="mine:embeddings")
def embeddings():
    data = np.load(data_dir() / "embeddings.npy")
    kmeans = MiniBatchKMeans(n_clusters=5,
                             random_state=0,
                             batch_size=6,
                             n_init="auto")
    model = kmeans.fit(data)
    clusters = model.predict(data)

    db = connect()

    stories = db.sql("""
        select
            id
        from stories
        order by id desc
    """).df()
    stories['cluster'] = clusters

    db.execute("drop table clusters")
    db.execute("CREATE TABLE clusters (story_id BIGINT, cluster integer)")
    db.append("clusters", stories)

@click.command(name="mine:cluster")
def cluster():

    import pandas as pd
    pd.set_option('display.max_rows', 100)
    pd.set_option('display.max_columns', 500)
    pd.set_option('display.width', 1000)
    df = db.sql("""
        select
            s.publisher
            ,c.cluster
            ,count(1) as total
        from clusters c
        join stories s
        on s.id = c.story_id
        group by
        s.publisher, c.cluster
    """).df()

    pivoted = df.pivot(index='publisher', columns='cluster', values='total').sort_values([0], ascending=False)
    pivoted[:25]

    db.sql("""
        select
            publisher
            ,title
        from clusters c
        join stories s
        on s.id = c.story_id
        where c.cluster = 0
    """)

    len(stories)
    data.shape

def main():
    db.sql("""
        select
            count(distinct publisher)
        from stories
    """)

    db.sql("""
        with cte as (
        select
            distinct title
        from stories
        )
        select
            max(length(title)) as max
            ,min(length(title)) as min
            ,avg(length(title)) as avg
            ,sum(length(title)) as characters
        from cte
    """).fetchall()
    """
    let's calculate the size of the word embeddings stored as a list in the database
    db.sql("""
        with cte as (
        select
            distinct title
        from stories
        )

    db.sql("""
        select
            count(distinct url)
        from stories
    """)
